Index: src/tesselationhelpers.cpp
===================================================================
--- src/tesselationhelpers.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/tesselationhelpers.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -8,4 +8,5 @@
 #include <fstream>
 
+#include "info.hpp"
 #include "linkedcell.hpp"
 #include "log.hpp"
@@ -15,5 +16,7 @@
 #include "verbose.hpp"
 
-double DetGet(gsl_matrix * const A, const int inPlace) {
+double DetGet(gsl_matrix * const A, const int inPlace)
+{
+	Info FunctionInfo(__func__);
   /*
   inPlace = 1 => A is replaced with the LU decomposed copy.
@@ -45,4 +48,5 @@
 void GetSphere(Vector * const center, const Vector &a, const Vector &b, const Vector &c, const double RADIUS)
 {
+	Info FunctionInfo(__func__);
   gsl_matrix *A = gsl_matrix_calloc(3,3);
   double m11, m12, m13, m14;
@@ -77,5 +81,5 @@
 
   if (fabs(m11) < MYEPSILON)
-    eLog() << Verbose(0) << "ERROR: three points are colinear." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "three points are colinear." << endl);
 
   center->x[0] =  0.5 * m12/ m11;
@@ -84,5 +88,5 @@
 
   if (fabs(a.Distance(center) - RADIUS) > MYEPSILON)
-    eLog() << Verbose(0) << "ERROR: The given center is further way by " << fabs(a.Distance(center) - RADIUS) << " from a than RADIUS." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "The given center is further way by " << fabs(a.Distance(center) - RADIUS) << " from a than RADIUS." << endl);
 
   gsl_matrix_free(A);
@@ -111,8 +115,8 @@
     const double HalfplaneIndicator, const double AlternativeIndicator, const double alpha, const double beta, const double gamma, const double RADIUS, const double Umkreisradius)
 {
+	Info FunctionInfo(__func__);
   Vector TempNormal, helper;
   double Restradius;
   Vector OtherCenter;
-  Log() << Verbose(3) << "Begin of GetCenterOfSphere.\n";
   Center->Zero();
   helper.CopyVector(&a);
@@ -128,7 +132,7 @@
   Center->Scale(1./(sin(2.*alpha) + sin(2.*beta) + sin(2.*gamma)));
   NewUmkreismittelpunkt->CopyVector(Center);
-  Log() << Verbose(4) << "Center of new circumference is " << *NewUmkreismittelpunkt << ".\n";
+  DoLog(1) && (Log() << Verbose(1) << "Center of new circumference is " << *NewUmkreismittelpunkt << ".\n");
   // Here we calculated center of circumscribing circle, using barycentric coordinates
-  Log() << Verbose(4) << "Center of circumference is " << *Center << " in direction " << *Direction << ".\n";
+  DoLog(1) && (Log() << Verbose(1) << "Center of circumference is " << *Center << " in direction " << *Direction << ".\n");
 
   TempNormal.CopyVector(&a);
@@ -139,5 +143,5 @@
   if (fabs(HalfplaneIndicator) < MYEPSILON)
     {
-      if ((TempNormal.ScalarProduct(AlternativeDirection) <0 and AlternativeIndicator >0) or (TempNormal.ScalarProduct(AlternativeDirection) >0 and AlternativeIndicator <0))
+      if ((TempNormal.ScalarProduct(AlternativeDirection) <0 && AlternativeIndicator >0) || (TempNormal.ScalarProduct(AlternativeDirection) >0 && AlternativeIndicator <0))
         {
           TempNormal.Scale(-1);
@@ -146,5 +150,5 @@
   else
     {
-      if (TempNormal.ScalarProduct(Direction)<0 && HalfplaneIndicator >0 || TempNormal.ScalarProduct(Direction)>0 && HalfplaneIndicator<0)
+      if (((TempNormal.ScalarProduct(Direction)<0) && (HalfplaneIndicator >0)) || ((TempNormal.ScalarProduct(Direction)>0) && (HalfplaneIndicator<0)))
         {
           TempNormal.Scale(-1);
@@ -154,13 +158,12 @@
   TempNormal.Normalize();
   Restradius = sqrt(RADIUS*RADIUS - Umkreisradius*Umkreisradius);
-  Log() << Verbose(4) << "Height of center of circumference to center of sphere is " << Restradius << ".\n";
+  DoLog(1) && (Log() << Verbose(1) << "Height of center of circumference to center of sphere is " << Restradius << ".\n");
   TempNormal.Scale(Restradius);
-  Log() << Verbose(4) << "Shift vector to sphere of circumference is " << TempNormal << ".\n";
+  DoLog(1) && (Log() << Verbose(1) << "Shift vector to sphere of circumference is " << TempNormal << ".\n");
 
   Center->AddVector(&TempNormal);
-  Log() << Verbose(0) << "Center of sphere of circumference is " << *Center << ".\n";
+  DoLog(1) && (Log() << Verbose(1) << "Center of sphere of circumference is " << *Center << ".\n");
   GetSphere(&OtherCenter, a, b, c, RADIUS);
-  Log() << Verbose(0) << "OtherCenter of sphere of circumference is " << OtherCenter << ".\n";
-  Log() << Verbose(3) << "End of GetCenterOfSphere.\n";
+  DoLog(1) && (Log() << Verbose(1) << "OtherCenter of sphere of circumference is " << OtherCenter << ".\n");
 };
 
@@ -174,4 +177,5 @@
 void GetCenterofCircumcircle(Vector * const Center, const Vector &a, const Vector &b, const Vector &c)
 {
+	Info FunctionInfo(__func__);
   Vector helper;
   double alpha, beta, gamma;
@@ -186,7 +190,8 @@
   beta = M_PI - SideC.Angle(&SideA);
   gamma = M_PI - SideA.Angle(&SideB);
-  //Log() << Verbose(3) << "INFO: alpha = " << alpha/M_PI*180. << ", beta = " << beta/M_PI*180. << ", gamma = " << gamma/M_PI*180. << "." << endl;
-  if (fabs(M_PI - alpha - beta - gamma) > HULLEPSILON)
-    eLog() << Verbose(0) << "GetCenterofCircumcircle: Sum of angles " << (alpha+beta+gamma)/M_PI*180. << " > 180 degrees by " << fabs(M_PI - alpha - beta - gamma)/M_PI*180. << "!" << endl;
+  //Log() << Verbose(1) << "INFO: alpha = " << alpha/M_PI*180. << ", beta = " << beta/M_PI*180. << ", gamma = " << gamma/M_PI*180. << "." << endl;
+  if (fabs(M_PI - alpha - beta - gamma) > HULLEPSILON) {
+    DoeLog(2) && (eLog()<< Verbose(2) << "GetCenterofCircumcircle: Sum of angles " << (alpha+beta+gamma)/M_PI*180. << " > 180 degrees by " << fabs(M_PI - alpha - beta - gamma)/M_PI*180. << "!" << endl);
+  }
 
   Center->Zero();
@@ -218,30 +223,37 @@
 double GetPathLengthonCircumCircle(const Vector &CircleCenter, const Vector &CirclePlaneNormal, const double CircleRadius, const Vector &NewSphereCenter, const Vector &OldSphereCenter, const Vector &NormalVector, const Vector &SearchDirection)
 {
+	Info FunctionInfo(__func__);
   Vector helper;
   double radius, alpha;
-
-  helper.CopyVector(&NewSphereCenter);
+  Vector RelativeOldSphereCenter;
+  Vector RelativeNewSphereCenter;
+
+  RelativeOldSphereCenter.CopyVector(&OldSphereCenter);
+  RelativeOldSphereCenter.SubtractVector(&CircleCenter);
+  RelativeNewSphereCenter.CopyVector(&NewSphereCenter);
+  RelativeNewSphereCenter.SubtractVector(&CircleCenter);
+  helper.CopyVector(&RelativeNewSphereCenter);
   // test whether new center is on the parameter circle's plane
   if (fabs(helper.ScalarProduct(&CirclePlaneNormal)) > HULLEPSILON) {
-    eLog() << Verbose(0) << "ERROR: Something's very wrong here: NewSphereCenter is not on the band's plane as desired by " <<fabs(helper.ScalarProduct(&CirclePlaneNormal))  << "!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Something's very wrong here: NewSphereCenter is not on the band's plane as desired by " <<fabs(helper.ScalarProduct(&CirclePlaneNormal))  << "!" << endl);
     helper.ProjectOntoPlane(&CirclePlaneNormal);
   }
-  radius = helper.ScalarProduct(&helper);
+  radius = helper.NormSquared();
   // test whether the new center vector has length of CircleRadius
   if (fabs(radius - CircleRadius) > HULLEPSILON)
-    eLog() << Verbose(1) << "ERROR: The projected center of the new sphere has radius " << radius << " instead of " << CircleRadius << "." << endl;
-  alpha = helper.Angle(&OldSphereCenter);
+    DoeLog(1) && (eLog()<< Verbose(1) << "The projected center of the new sphere has radius " << radius << " instead of " << CircleRadius << "." << endl);
+  alpha = helper.Angle(&RelativeOldSphereCenter);
   // make the angle unique by checking the halfplanes/search direction
   if (helper.ScalarProduct(&SearchDirection) < -HULLEPSILON)  // acos is not unique on [0, 2.*M_PI), hence extra check to decide between two half intervals
     alpha = 2.*M_PI - alpha;
-  //Log() << Verbose(2) << "INFO: RelativeNewSphereCenter is " << helper << ", RelativeOldSphereCenter is " << OldSphereCenter << " and resulting angle is " << alpha << "." << endl;
-  radius = helper.Distance(&OldSphereCenter);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: RelativeNewSphereCenter is " << helper << ", RelativeOldSphereCenter is " << RelativeOldSphereCenter << " and resulting angle is " << alpha << "." << endl);
+  radius = helper.Distance(&RelativeOldSphereCenter);
   helper.ProjectOntoPlane(&NormalVector);
   // check whether new center is somewhat away or at least right over the current baseline to prevent intersecting triangles
   if ((radius > HULLEPSILON) || (helper.Norm() < HULLEPSILON)) {
-    //Log() << Verbose(2) << "INFO: Distance between old and new center is " << radius << " and between new center and baseline center is " << helper.Norm() << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Distance between old and new center is " << radius << " and between new center and baseline center is " << helper.Norm() << "." << endl);
     return alpha;
   } else {
-    //Log() << Verbose(1) << "INFO: NewSphereCenter " << helper << " is too close to OldSphereCenter" << OldSphereCenter << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: NewSphereCenter " << RelativeNewSphereCenter << " is too close to RelativeOldSphereCenter" << RelativeOldSphereCenter << "." << endl);
     return 2.*M_PI;
   }
@@ -263,4 +275,5 @@
 double MinIntersectDistance(const gsl_vector * x, void *params)
 {
+	Info FunctionInfo(__func__);
   double retval = 0;
   struct Intersection *I = (struct Intersection *)params;
@@ -283,5 +296,5 @@
 
   retval = HeightA.ScalarProduct(&HeightA) + HeightB.ScalarProduct(&HeightB);
-  //Log() << Verbose(2) << "MinIntersectDistance called, result: " << retval << endl;
+  //Log() << Verbose(1) << "MinIntersectDistance called, result: " << retval << endl;
 
   return retval;
@@ -303,4 +316,5 @@
 bool existsIntersection(const Vector &point1, const Vector &point2, const Vector &point3, const Vector &point4)
 {
+	Info FunctionInfo(__func__);
   bool result;
 
@@ -350,5 +364,5 @@
 
         if (status == GSL_SUCCESS) {
-          Log() << Verbose(2) << "converged to minimum" <<  endl;
+          DoLog(1) && (Log() << Verbose(1) << "converged to minimum" <<  endl);
         }
     } while (status == GSL_CONTINUE && iter < 100);
@@ -375,13 +389,13 @@
   t2 = HeightB.ScalarProduct(&SideB)/SideB.ScalarProduct(&SideB);
 
-  Log() << Verbose(2) << "Intersection " << intersection << " is at "
+  Log() << Verbose(1) << "Intersection " << intersection << " is at "
     << t1 << " for (" << point1 << "," << point2 << ") and at "
     << t2 << " for (" << point3 << "," << point4 << "): ";
 
   if (((t1 >= 0) && (t1 <= 1)) && ((t2 >= 0) && (t2 <= 1))) {
-    Log() << Verbose(0) << "true intersection." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "true intersection." << endl);
     result = true;
   } else {
-    Log() << Verbose(0) << "intersection out of region of interest." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "intersection out of region of interest." << endl);
     result = false;
   }
@@ -406,4 +420,5 @@
 double GetAngle(const Vector &point, const Vector &reference, const Vector &OrthogonalVector)
 {
+	Info FunctionInfo(__func__);
   if (reference.IsZero())
     return M_PI;
@@ -417,5 +432,5 @@
   }
 
-  Log() << Verbose(4) << "INFO: " << point << " has angle " << phi << " with respect to reference " << reference << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: " << point << " has angle " << phi << " with respect to reference " << reference << "." << endl);
 
   return phi;
@@ -432,4 +447,5 @@
 double CalculateVolumeofGeneralTetraeder(const Vector &a, const Vector &b, const Vector &c, const Vector &d)
 {
+	Info FunctionInfo(__func__);
   Vector Point, TetraederVector[3];
   double volume;
@@ -455,4 +471,5 @@
 bool CheckLineCriteriaForDegeneratedTriangle(const BoundaryPointSet * const nodes[3])
 {
+	Info FunctionInfo(__func__);
   bool result = false;
   int counter = 0;
@@ -461,5 +478,8 @@
   for (int i=0;i<3;i++)
     for (int j=i+1; j<3; j++) {
-      if (nodes[i]->lines.find(nodes[j]->node->nr) != nodes[i]->lines.end()) {  // there already is a line
+      if (nodes[i] == NULL) {
+        DoLog(1) && (Log() << Verbose(1) << "Node nr. " << i << " is not yet present." << endl);
+        result = true;
+      } else if (nodes[i]->lines.find(nodes[j]->node->nr) != nodes[i]->lines.end()) {  // there already is a line
         LineMap::const_iterator FindLine;
         pair<LineMap::const_iterator,LineMap::const_iterator> FindPair;
@@ -473,10 +493,10 @@
         }
       } else { // no line
-        Log() << Verbose(1) << "The line between " << *nodes[i] << " and " << *nodes[j] << " is not yet present, hence no need for a degenerate triangle." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "The line between " << *nodes[i] << " and " << *nodes[j] << " is not yet present, hence no need for a degenerate triangle." << endl);
         result = true;
       }
     }
   if ((!result) && (counter > 1)) {
-    Log() << Verbose(2) << "INFO: Degenerate triangle is ok, at least two, here " << counter << ", existing lines are used." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Degenerate triangle is ok, at least two, here " << counter << ", existing lines are used." << endl);
     result = true;
   }
@@ -485,47 +505,48 @@
 
 
-/** Sort function for the candidate list.
- */
-bool SortCandidates(const CandidateForTesselation* candidate1, const CandidateForTesselation* candidate2)
-{
-  Vector BaseLineVector, OrthogonalVector, helper;
-  if (candidate1->BaseLine != candidate2->BaseLine) {  // sanity check
-    Log() << Verbose(0) << "ERROR: sortCandidates was called for two different baselines: " << candidate1->BaseLine << " and " << candidate2->BaseLine << "." << endl;
-    //return false;
-    exit(1);
-  }
-  // create baseline vector
-  BaseLineVector.CopyVector(candidate1->BaseLine->endpoints[1]->node->node);
-  BaseLineVector.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
-  BaseLineVector.Normalize();
-
-  // create normal in-plane vector to cope with acos() non-uniqueness on [0,2pi] (note that is pointing in the "right" direction already, hence ">0" test!)
-  helper.CopyVector(candidate1->BaseLine->endpoints[0]->node->node);
-  helper.SubtractVector(candidate1->point->node);
-  OrthogonalVector.CopyVector(&helper);
-  helper.VectorProduct(&BaseLineVector);
-  OrthogonalVector.SubtractVector(&helper);
-  OrthogonalVector.Normalize();
-
-  // calculate both angles and correct with in-plane vector
-  helper.CopyVector(candidate1->point->node);
-  helper.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
-  double phi = BaseLineVector.Angle(&helper);
-  if (OrthogonalVector.ScalarProduct(&helper) > 0) {
-    phi = 2.*M_PI - phi;
-  }
-  helper.CopyVector(candidate2->point->node);
-  helper.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
-  double psi = BaseLineVector.Angle(&helper);
-  if (OrthogonalVector.ScalarProduct(&helper) > 0) {
-    psi = 2.*M_PI - psi;
-  }
-
-  Log() << Verbose(2) << *candidate1->point << " has angle " << phi << endl;
-  Log() << Verbose(2) << *candidate2->point << " has angle " << psi << endl;
-
-  // return comparison
-  return phi < psi;
-};
+///** Sort function for the candidate list.
+// */
+//bool SortCandidates(const CandidateForTesselation* candidate1, const CandidateForTesselation* candidate2)
+//{
+//	Info FunctionInfo(__func__);
+//  Vector BaseLineVector, OrthogonalVector, helper;
+//  if (candidate1->BaseLine != candidate2->BaseLine) {  // sanity check
+//    DoeLog(1) && (eLog()<< Verbose(1) << "sortCandidates was called for two different baselines: " << candidate1->BaseLine << " and " << candidate2->BaseLine << "." << endl);
+//    //return false;
+//    exit(1);
+//  }
+//  // create baseline vector
+//  BaseLineVector.CopyVector(candidate1->BaseLine->endpoints[1]->node->node);
+//  BaseLineVector.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
+//  BaseLineVector.Normalize();
+//
+//  // create normal in-plane vector to cope with acos() non-uniqueness on [0,2pi] (note that is pointing in the "right" direction already, hence ">0" test!)
+//  helper.CopyVector(candidate1->BaseLine->endpoints[0]->node->node);
+//  helper.SubtractVector(candidate1->point->node);
+//  OrthogonalVector.CopyVector(&helper);
+//  helper.VectorProduct(&BaseLineVector);
+//  OrthogonalVector.SubtractVector(&helper);
+//  OrthogonalVector.Normalize();
+//
+//  // calculate both angles and correct with in-plane vector
+//  helper.CopyVector(candidate1->point->node);
+//  helper.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
+//  double phi = BaseLineVector.Angle(&helper);
+//  if (OrthogonalVector.ScalarProduct(&helper) > 0) {
+//    phi = 2.*M_PI - phi;
+//  }
+//  helper.CopyVector(candidate2->point->node);
+//  helper.SubtractVector(candidate1->BaseLine->endpoints[0]->node->node);
+//  double psi = BaseLineVector.Angle(&helper);
+//  if (OrthogonalVector.ScalarProduct(&helper) > 0) {
+//    psi = 2.*M_PI - psi;
+//  }
+//
+//  Log() << Verbose(1) << *candidate1->point << " has angle " << phi << endl;
+//  Log() << Verbose(1) << *candidate2->point << " has angle " << psi << endl;
+//
+//  // return comparison
+//  return phi < psi;
+//};
 
 /**
@@ -537,6 +558,7 @@
  * @return point which is second closest to the provided one
  */
-TesselPoint* FindSecondClosestPoint(const Vector* Point, const LinkedCell* const LC)
-{
+TesselPoint* FindSecondClosestTesselPoint(const Vector* Point, const LinkedCell* const LC)
+{
+	Info FunctionInfo(__func__);
   TesselPoint* closestPoint = NULL;
   TesselPoint* secondClosestPoint = NULL;
@@ -549,15 +571,15 @@
   for(int i=0;i<NDIM;i++) // store indices of this cell
     N[i] = LC->n[i];
-  Log() << Verbose(2) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl);
 
   LC->GetNeighbourBounds(Nlower, Nupper);
-  //Log() << Verbose(0) << endl;
+  //Log() << Verbose(1) << endl;
   for (LC->n[0] = Nlower[0]; LC->n[0] <= Nupper[0]; LC->n[0]++)
     for (LC->n[1] = Nlower[1]; LC->n[1] <= Nupper[1]; LC->n[1]++)
       for (LC->n[2] = Nlower[2]; LC->n[2] <= Nupper[2]; LC->n[2]++) {
-        const LinkedNodes *List = LC->GetCurrentCell();
-        //Log() << Verbose(3) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << endl;
+        const LinkedCell::LinkedNodes *List = LC->GetCurrentCell();
+        //Log() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << endl;
         if (List != NULL) {
-          for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
+          for (LinkedCell::LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
             helper.CopyVector(Point);
             helper.SubtractVector((*Runner)->node);
@@ -574,5 +596,5 @@
           }
         } else {
-          eLog() << Verbose(0) << "ERROR: The current cell " << LC->n[0] << "," << LC->n[1] << ","
+          eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << ","
             << LC->n[2] << " is invalid!" << endl;
         }
@@ -591,6 +613,7 @@
  * @return point which is closest to the provided one, NULL if none found
  */
-TesselPoint* FindClosestPoint(const Vector* Point, TesselPoint *&SecondPoint, const LinkedCell* const LC)
-{
+TesselPoint* FindClosestTesselPoint(const Vector* Point, TesselPoint *&SecondPoint, const LinkedCell* const LC)
+{
+	Info FunctionInfo(__func__);
   TesselPoint* closestPoint = NULL;
   SecondPoint = NULL;
@@ -603,18 +626,18 @@
   for(int i=0;i<NDIM;i++) // store indices of this cell
     N[i] = LC->n[i];
-  Log() << Verbose(3) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl);
 
   LC->GetNeighbourBounds(Nlower, Nupper);
-  //Log() << Verbose(0) << endl;
+  //Log() << Verbose(1) << endl;
   for (LC->n[0] = Nlower[0]; LC->n[0] <= Nupper[0]; LC->n[0]++)
     for (LC->n[1] = Nlower[1]; LC->n[1] <= Nupper[1]; LC->n[1]++)
       for (LC->n[2] = Nlower[2]; LC->n[2] <= Nupper[2]; LC->n[2]++) {
-        const LinkedNodes *List = LC->GetCurrentCell();
-        //Log() << Verbose(3) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << endl;
+        const LinkedCell::LinkedNodes *List = LC->GetCurrentCell();
+        //Log() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << endl;
         if (List != NULL) {
-          for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
+          for (LinkedCell::LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
             helper.CopyVector(Point);
             helper.SubtractVector((*Runner)->node);
-            double currentNorm = helper. Norm();
+            double currentNorm = helper.NormSquared();
             if (currentNorm < distance) {
               secondDistance = distance;
@@ -622,13 +645,13 @@
               distance = currentNorm;
               closestPoint = (*Runner);
-              //Log() << Verbose(2) << "INFO: New Nearest Neighbour is " << *closestPoint << "." << endl;
+              //Log() << Verbose(1) << "INFO: New Nearest Neighbour is " << *closestPoint << "." << endl;
             } else if (currentNorm < secondDistance) {
               secondDistance = currentNorm;
               SecondPoint = (*Runner);
-              //Log() << Verbose(2) << "INFO: New Second Nearest Neighbour is " << *SecondPoint << "." << endl;
+              //Log() << Verbose(1) << "INFO: New Second Nearest Neighbour is " << *SecondPoint << "." << endl;
             }
           }
         } else {
-          eLog() << Verbose(0) << "ERROR: The current cell " << LC->n[0] << "," << LC->n[1] << ","
+          eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << ","
             << LC->n[2] << " is invalid!" << endl;
         }
@@ -636,8 +659,8 @@
   // output
   if (closestPoint != NULL) {
-    Log() << Verbose(2) << "Closest point is " << *closestPoint;
+    DoLog(1) && (Log() << Verbose(1) << "Closest point is " << *closestPoint);
     if (SecondPoint != NULL)
-      Log() << Verbose(0) << " and second closest is " << *SecondPoint;
-    Log() << Verbose(0) << "." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " and second closest is " << *SecondPoint);
+    DoLog(0) && (Log() << Verbose(0) << "." << endl);
   }
   return closestPoint;
@@ -652,4 +675,5 @@
 Vector * GetClosestPointBetweenLine(const BoundaryLineSet * const Base, const BoundaryLineSet * const OtherBase)
 {
+	Info FunctionInfo(__func__);
   // construct the plane of the two baselines (i.e. take both their directional vectors)
   Vector Normal;
@@ -662,5 +686,5 @@
   Normal.VectorProduct(&OtherBaseline);
   Normal.Normalize();
-  Log() << Verbose(4) << "First direction is " << Baseline << ", second direction is " << OtherBaseline << ", normal of intersection plane is " << Normal << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "First direction is " << Baseline << ", second direction is " << OtherBaseline << ", normal of intersection plane is " << Normal << "." << endl);
 
   // project one offset point of OtherBase onto this plane (and add plane offset vector)
@@ -679,5 +703,5 @@
   Normal.CopyVector(Intersection);
   Normal.SubtractVector(Base->endpoints[0]->node->node);
-  Log() << Verbose(3) << "Found closest point on " << *Base << " at " << *Intersection << ", factor in line is " << fabs(Normal.ScalarProduct(&Baseline)/Baseline.NormSquared()) << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Found closest point on " << *Base << " at " << *Intersection << ", factor in line is " << fabs(Normal.ScalarProduct(&Baseline)/Baseline.NormSquared()) << "." << endl);
 
   return Intersection;
@@ -692,4 +716,5 @@
 double DistanceToTrianglePlane(const Vector *x, const BoundaryTriangleSet * const triangle)
 {
+	Info FunctionInfo(__func__);
   double distance = 0.;
   if (x == NULL) {
@@ -708,4 +733,5 @@
 void WriteVrmlFile(ofstream * const vrmlfile, const Tesselation * const Tess, const PointCloud * const cloud)
 {
+	Info FunctionInfo(__func__);
   TesselPoint *Walker = NULL;
   int i;
@@ -738,5 +764,5 @@
     }
   } else {
-    eLog() << Verbose(0) << "ERROR: Given vrmlfile is " << vrmlfile << "." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Given vrmlfile is " << vrmlfile << "." << endl);
   }
   delete(center);
@@ -751,19 +777,23 @@
 void IncludeSphereinRaster3D(ofstream * const rasterfile, const Tesselation * const Tess, const PointCloud * const cloud)
 {
+	Info FunctionInfo(__func__);
   Vector helper;
-  // include the current position of the virtual sphere in the temporary raster3d file
-  Vector *center = cloud->GetCenter();
-  // make the circumsphere's center absolute again
-  helper.CopyVector(Tess->LastTriangle->endpoints[0]->node->node);
-  helper.AddVector(Tess->LastTriangle->endpoints[1]->node->node);
-  helper.AddVector(Tess->LastTriangle->endpoints[2]->node->node);
-  helper.Scale(1./3.);
-  helper.SubtractVector(center);
-  // and add to file plus translucency object
-  *rasterfile << "# current virtual sphere\n";
-  *rasterfile << "8\n  25.0    0.6     -1.0 -1.0 -1.0     0.2        0 0 0 0\n";
-  *rasterfile << "2\n  " << helper.x[0] << " " << helper.x[1] << " " << helper.x[2] << "\t" << 5. << "\t1 0 0\n";
-  *rasterfile << "9\n  terminating special property\n";
-  delete(center);
+
+  if (Tess->LastTriangle != NULL) {
+    // include the current position of the virtual sphere in the temporary raster3d file
+    Vector *center = cloud->GetCenter();
+    // make the circumsphere's center absolute again
+    helper.CopyVector(Tess->LastTriangle->endpoints[0]->node->node);
+    helper.AddVector(Tess->LastTriangle->endpoints[1]->node->node);
+    helper.AddVector(Tess->LastTriangle->endpoints[2]->node->node);
+    helper.Scale(1./3.);
+    helper.SubtractVector(center);
+    // and add to file plus translucency object
+    *rasterfile << "# current virtual sphere\n";
+    *rasterfile << "8\n  25.0    0.6     -1.0 -1.0 -1.0     0.2        0 0 0 0\n";
+    *rasterfile << "2\n  " << helper.x[0] << " " << helper.x[1] << " " << helper.x[2] << "\t" << 5. << "\t1 0 0\n";
+    *rasterfile << "9\n  terminating special property\n";
+    delete(center);
+  }
 };
 
@@ -776,4 +806,5 @@
 void WriteRaster3dFile(ofstream * const rasterfile, const Tesselation * const Tess, const PointCloud * const cloud)
 {
+	Info FunctionInfo(__func__);
   TesselPoint *Walker = NULL;
   int i;
@@ -808,5 +839,5 @@
     *rasterfile << "9\n#  terminating special property\n";
   } else {
-    eLog() << Verbose(0) << "ERROR: Given rasterfile is " << rasterfile << "." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Given rasterfile is " << rasterfile << "." << endl);
   }
   IncludeSphereinRaster3D(rasterfile, Tess, cloud);
@@ -821,14 +852,23 @@
 void WriteTecplotFile(ofstream * const tecplot, const Tesselation * const TesselStruct, const PointCloud * const cloud, const int N)
 {
+	Info FunctionInfo(__func__);
   if ((tecplot != NULL) && (TesselStruct != NULL)) {
     // write header
     *tecplot << "TITLE = \"3D CONVEX SHELL\"" << endl;
     *tecplot << "VARIABLES = \"X\" \"Y\" \"Z\" \"U\"" << endl;
-    *tecplot << "ZONE T=\"" << N << "-";
-    for (int i=0;i<3;i++)
-      *tecplot << (i==0 ? "" : "_") << TesselStruct->LastTriangle->endpoints[i]->node->Name;
+    *tecplot << "ZONE T=\"";
+    if (N < 0) {
+      *tecplot << cloud->GetName();
+    } else {
+      *tecplot << N << "-";
+      if (TesselStruct->LastTriangle != NULL) {
+        for (int i=0;i<3;i++)
+          *tecplot << (i==0 ? "" : "_") << TesselStruct->LastTriangle->endpoints[i]->node->Name;
+      } else {
+        *tecplot << "none";
+      }
+    }
     *tecplot << "\", N=" << TesselStruct->PointsOnBoundary.size() << ", E=" << TesselStruct->TrianglesOnBoundary.size() << ", DATAPACKING=POINT, ZONETYPE=FETRIANGLE" << endl;
-    int i=0;
-    for (cloud->GoToFirst(); !cloud->IsEnd(); cloud->GoToNext(), i++);
+    int i=cloud->GetMaxId();
     int *LookupList = new int[i];
     for (cloud->GoToFirst(), i=0; !cloud->IsEnd(); cloud->GoToNext(), i++)
@@ -836,5 +876,4 @@
 
     // print atom coordinates
-    Log() << Verbose(2) << "The following triangles were created:";
     int Counter = 1;
     TesselPoint *Walker = NULL;
@@ -846,10 +885,10 @@
     *tecplot << endl;
     // print connectivity
+    DoLog(1) && (Log() << Verbose(1) << "The following triangles were created:" << endl);
     for (TriangleMap::const_iterator runner = TesselStruct->TrianglesOnBoundary.begin(); runner != TesselStruct->TrianglesOnBoundary.end(); runner++) {
-      Log() << Verbose(0) << " " << runner->second->endpoints[0]->node->Name << "<->" << runner->second->endpoints[1]->node->Name << "<->" << runner->second->endpoints[2]->node->Name;
+      DoLog(1) && (Log() << Verbose(1) << " " << runner->second->endpoints[0]->node->Name << "<->" << runner->second->endpoints[1]->node->Name << "<->" << runner->second->endpoints[2]->node->Name << endl);
       *tecplot << LookupList[runner->second->endpoints[0]->node->nr] << " " << LookupList[runner->second->endpoints[1]->node->nr] << " " << LookupList[runner->second->endpoints[2]->node->nr] << endl;
     }
     delete[] (LookupList);
-    Log() << Verbose(0) << endl;
   }
 };
@@ -862,21 +901,20 @@
 void CalculateConcavityPerBoundaryPoint(const Tesselation * const TesselStruct)
 {
+	Info FunctionInfo(__func__);
   class BoundaryPointSet *point = NULL;
   class BoundaryLineSet *line = NULL;
 
-  //Log() << Verbose(2) << "Begin of CalculateConcavityPerBoundaryPoint" << endl;
   // calculate remaining concavity
   for (PointMap::const_iterator PointRunner = TesselStruct->PointsOnBoundary.begin(); PointRunner != TesselStruct->PointsOnBoundary.end(); PointRunner++) {
     point = PointRunner->second;
-    Log() << Verbose(1) << "INFO: Current point is " << *point << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Current point is " << *point << "." << endl);
     point->value = 0;
     for (LineMap::iterator LineRunner = point->lines.begin(); LineRunner != point->lines.end(); LineRunner++) {
       line = LineRunner->second;
-      //Log() << Verbose(2) << "INFO: Current line of point " << *point << " is " << *line << "." << endl;
+      //Log() << Verbose(1) << "INFO: Current line of point " << *point << " is " << *line << "." << endl;
       if (!line->CheckConvexityCriterion())
         point->value += 1;
     }
   }
-  //Log() << Verbose(2) << "End of CalculateConcavityPerBoundaryPoint" << endl;
 };
 
